#!/usr/bin/perl

# Copyright (C) 2003, 2004
# Emmanuel Saracco <esaracco@noos.fr>
# Easter-eggs <http://www.easter-eggs.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330,
# Boston, MA 02111-1307, USA.

require './clamav-lib.pl';
&ReadParse ();

&header($text{'FORM_TITLE'}, "", undef, 1, 0);
print "<hr>\n";

&clamav_quarantine_main_check_config ();

print qq(<h1>$text{'QUARANTINE_PAGE_TITLE'}</h1>\n);

if (defined $in{'resended'})
{
  print qq(<h3>$text{'MSG_SUCCESS_STATUS_RESEND'}</h3>);
}
elsif (defined $in{'removed'})
{
  print qq(<h3>$text{'MSG_SUCCESS_STATUS_REMOVE'}</h3>);
}

print qq(<p>$text{'QUARANTINE_PAGE_DESCRIPTION'}</p>);

print qq(<h1>$text{'QUARANTINE_CLEANING'}</h1>);

print qq(<p>$text{'QUARANTINE_CRON_DESCRIPTION'}</p>);

if ($in{'next'})
{
  if ($in{'nopurge'} eq 'on')
  {
    &clamav_delete_cron ('purge');
  }
  else
  {
    &clamav_set_cron_purge ($in{'hour'}, $in{'day'});
  }
 
  print "<p><b>$text{'MSG_SUCCESS_QUARANTINE_CRON_UPDATE'}</b></p>";
}

@cron_line = &clamav_get_cron_settings ('purge');

print qq(<form method="POST" action="$scriptname">\n);
print &clamav_cron_settings_table ($cron_line[0], $cron_line[4]);

$checked = ($#cron_line <= 0) ? ' CHECKED' : '';
print qq(<p>);
print qq(<input type="checkbox" name="nopurge" value="on"$checked>);
print qq( $text{'QUARANTINE_PURGE_NEVER'});
print qq(</p>);

print qq(<p>);
print qq(<input type="submit" name="next" value="$text{'APPLY'}">);
print qq(</p>);

print qq(</form>);

print qq(<h1>$text{'QUARANTINE_RESEARCH'}</h1>);

print qq(<p>$text{'QUARANTINE_RESEARCH_DESCRIPTION'}</p>);

print qq(
  <form action="quarantine_main.cgi" method="POST">
  <table border=0 bgcolor="silver">
  <tr><td $cb><b>$text{'VIRUS'}</b>:</td><td><input type="text" name="virus_name" value="$in{'virus_name'}"></td><td>&nbsp;</td></tr>
  <tr><td $cb><b>$text{'SENDER'}</b>:</td><td><input type="text" name="mail_from" value="$in{'mail_from'}"></td><td><input type="submit" value="$text{'SEARCH'}" name="search"></td></tr>
  <tr><td $cb><b>$text{'RECIPIENT'}</b>:</td><td><input type="text" name="mail_to" value="$in{'mail_to'}"></td><td>&nbsp;</td></tr>
  <tr><td $cb valign="top"><b>$text{'PERIOD'}</b>:</td><td colspan="2" nowrap valign="top">);
&clamav_get_period_chooser ($in{'day1'}, $in{'month1'}, $in{'year1'}, $in{'day2'}, $in{'month2'}, $in{'year2'});
print qq(
  </td></tr>
  </table>
  </form>  
  <p>
);

# if form submit, do the quarantine search
if ($in{'search'})
{
  if (&clamav_is_quarantine_repository_empty ())
  {
    print qq(<p><b>$text{'LINK_QUANRANTINE_EMPTY_PAGE'}</b></p>);
  }
  else
  {
    # if amavis-ng is installed
    if (&clamav_is_amavis_ng ())
    {
      $page_count = &clamav_print_quarantine_table_amavis_ng (
        $in{'total'},
        $in{'cp'},
        $in{'virus_name'},
        $in{'mail_from'}, $in{'mail_to'}, 
	$in{'day1'}, $in{'month1'}, $in{'year1'}, 
	$in{'day2'}, $in{'month2'}, $in{'year2'});
    }
    # if amavisd-new is installed
    elsif (&clamav_is_amavisd_new ())
    {
      $page_count = &clamav_print_quarantine_table_amavisd_new (
        $in{'total'},
        $in{'cp'},
        $in{'virus_name'},
        $in{'mail_from'}, $in{'mail_to'}, 
	$in{'day1'}, $in{'month1'}, $in{'year1'}, 
	$in{'day2'}, $in{'month2'}, $in{'year2'});
    }
  }

  &clamav_display_page_panel ($in{'cp'}, $page_count);
}

print qq(<hr>);
&footer("", $text{'RETURN_INDEX_MODULE'});
